<template>
  <div>

    <div>
      <i-form :model="page" inline :label-width="80">
        <form-item label="Название">
          <i-input v-model="page.name" type="text" placeholder="Название">
          </i-input>
        </form-item>
        <form-item label="Выражение">
          <i-input v-model="page.expression" type="text" placeholder="Выражение">
          </i-input>
        </form-item>
        <form-item label="Текущее состояние">
          <i-select v-model="page.status" style="width:200px">
            <Option value="0">Все</Option>
            <Option value="1">Ожидание</Option>
            <Option value="2">Начало</Option>
            <Option value="3">Успешно</Option>
            <Option value="4">Неудача</Option>
          </i-select>
        </form-item>
        <i-button type="primary" icon="ios-search" @click="loadPage">Проверить</i-button> &nbsp;&nbsp;
        <i-button type="success" v-model="showPut" icon="ios-add-circle" @click="windowAddContainer">Добавить
        </i-button>
      </i-form>
    </div>
    <div>
      <Table border :columns="columns" :data="containers">
        <template slot-scope="{ row }" slot="disable">
          <i-switch size="large" v-model="row.disable" @on-change="changeContainer(row)">
          </i-switch>
        </template>
        <template slot-scope="{ row }" slot="action">
          <Button type="info" size="small" @click="viewConfig(row)">Выделить</Button>
          <Button type="primary" size="small" @click="rowPutContainer(row)">Редактировать</Button>
          <Button type="error" size="small" @click="confirmRemove(row)">Стереть</Button>
          <Button type="info" size="small" @click="runContainer(row)">Управлять</Button>
        </template>
      </Table>
      <div style="margin: 10px;overflow: hidden">
        <div style="float: right;">
          <Page :total="page.total" :page-size="page.count" @on-change="changePageIndex"
                @on-page-size-change="changePageSize" show-sizer/>
        </div>
      </div>
    </div>
    <div>
      <Modal v-model="showPut" title="Редактор" @on-ok="updateContainer">
        <i-form ref="form" :model="container" :label-width="80">
          <FormItem label="Номер контейнера">
            <i-input v-model="container.cid" disabled></i-input>
          </FormItem>
          <FormItem label="Описание задачи">
            <i-input v-model="container.name"></i-input>
          </FormItem>

          <FormItem label="Выражение">
            <i-input v-model="container.expression"></i-input>
          </FormItem>
          <FormItem label="Отключить задачу">
            <i-switch v-model="container.disable"></i-switch>
          </FormItem>
        </i-form>
      </Modal>
    </div>
  </div>
</template>

<script>
import { getContainers, putContainer, deleteContainer, runContainer } from '../../api/container'
import { getDateTimeStr } from '@/libs/util'

export default {
  name: 'ContainerList',
  mounted: function () {
    this.loadPage()
  },

  data () {
    return {
      containers: [],
      showPut: false,
      page: {
        expression: '',
        name: '',
        order: 'cid',
        status: 0,
        total: 0,
        index: 1,
        count: 20
      },
      container: {
        cid: 0,
        name: '',
        expression: '',
        disable: false
      },
      statusBtn: {
        1: {
          props: {
            type: 'info',
            size: 'small',
            icon: 'md-arrow-down'
          },
          text: 'Ожидание'
        },
        2: {
          props: {
            type: 'primary',
            size: 'small',
            loading: true
          },
          text: 'Продолжить'
        },
        3: {
          props: {
            type: 'success',
            size: 'small',
            icon: 'md-checkmark'
          },
          text: 'Успешно'
        },
        4: {
          props: {
            size: 'small',
            type: 'error',
            icon: 'md-close'
          },
          text: 'Неудача'
        }
      },
      search: '',
      columns: [
        {
          title: 'Состояние',
          key: 'status',
          width: '120',
          render: (h, params) => {
            let status = params.row.status
            let p = this.statusBtn[status.toString()]
            return h('Button', {
              props: p.props
            }, p.text)
          }
        },
        {
          title: 'CID',
          key: 'cid',
          width: '80'
        },
        {
          title: 'Время работы',
          key: 'update_at',
          render: (h, params) => {
            let status = params.row.update_at
            console.log(status)
            let p = getDateTimeStr(status)
            return h('Span', {}, p)
          }
        },
        {
          title: 'Disable',
          key: 'disable',
          slot: 'disable',
          width: '100'
        },

        {
          title: 'Имя контейнера',
          key: 'name',
          tooltip: true
        },
        {
          title: 'Выражение',
          key: 'expression'
        },
        {
          title: 'Управлять',
          key: 'action',
          align: 'center',
          slot: 'action',
          width: '240'
        }
      ]
    }
  },

  methods: {
    loadPage: function () {
      getContainers(this.page).then(data => {
        this.containers = data.items
        this.page.total = data.page.total
      })
    },

    updateContainer: function () {
      putContainer(this.container).then(() => {
        this.$Message.success('Успешная операция!')
        this.loadPage()
      }
      )
    },

    rowPutContainer: function (row) {
      this.container = row
      this.showPut = true
    },
    windowAddContainer: function () {
      this.container = {
        cid: 0,
        name: '',
        expression: '',
        disable: false
      }
      this.showPut = true
    },
    changePageIndex: function (page) {
      this.page.index = page
      this.loadPage()
    },
    changePageSize: function (size) {
      this.page.index = 1
      this.page.count = size
      this.loadPage()
    },
    runContainer: function (container) {
      this.$Message.info('Открытая задача')
      runContainer(container).then(() => {
        this.$Message.success('Успешная операция!')
      })
      this.loadPage()
    },
    confirmRemove: function (container) {
      let cur = this
      this.$Modal.confirm({
        title: 'Подтвердить',
        content: '<p>Удалить текущую задачу?</p>',
        onOk: () => {
          cur.remove(container)
        }
      })
    },
    remove: function (container) {
      deleteContainer(container.cid).then(() => {
        this.$Message.success('Успешно удалено!')
        this.loadPage()
      })
    },
    changeContainer: function (container) {
      putContainer(container).then(() => {
        this.$Message.success('Успешная операция!')
        this.loadPage()
      }
      )
    },
    viewConfig: function (container) {
      this.$router.push({ name: 'container-config', params: { cid: container.cid } })
    }
  }
}
</script>
